<?php
    $AjaxFunctions['showPortabilityGW'] = 'showPortabilityGW';
    $AjaxFunctions['savePortabilityGW'] = 'savePortabilityGW';
    $AjaxFunctions['showLocalPortabilityGW'] = 'showLocalPortabilityGW';
    $AjaxFunctions['importPortabilityFileGW'] = 'importPortabilityFileGW';

    class KFormatHelper
    {
        public function help( $name )
        {
            return "<img class=\"gateway-tooltip\" src=\"/imagens/tooltip.png\" khelp=\"{$name}\" />";
        }

    };

    function showPortabilityGW( )
    {
        $app = KSystem::getInstance( );

        $buff = "<fieldset><legend>{$app->translate( 'gateway-portability' )}</legend>";
        $buff .= '<table class=\'zebra simpleTable gateway-table-form\'><tbody>';
        $buff .= "<tr><td class='label'><label for='gateway-portability-driver'>{$app->translate( 'gateway-portability-driver' )}</label>:</td><td><select id='gateway-portability-driver'></select></td></tr>";
        $buff .= '</tbody></table><br /><div id="gateway-portability-options" class="displayNone">&nbsp;</div>';
        $buff .= "<br /><div class='textAlignRight'><input id='gateway-portability-save' type='button' value='{$app->translate( 'save' )}' /></div>";
        $buff .= "</fieldset>";

        return $buff;
    }

    function savePortabilityGW()
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayYaml.php';

        $app = KSystem::getInstance( );

        $return = array( 'success' => false, 'message' => 'gateway-portability-error-save' );
        try
        {
            $gatewayyaml = new KGatewayYaml();
            $gatewayyaml->setPortability( $_POST['Driver'], $_POST['DriverOptions'] );
            $gatewayyaml->save();
            $return = array( 'success' => true, 'message' => $app->translate( 'gateway-portability-saved' ) );
        }
        catch( Exception $e )
        {
            $return['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $return );
    }

    function showLocalPortabilityGW( )
    {
        require_once KCONFIG . '/classes/KGatewayPortabilityImport.php';

        $app = KSystem::getInstance( );
        $portability = KGatewayPortabilityImport::getInstance( );
        $fmt = new KFormatHelper( );

        $buff = "<fieldset><legend>{$app->translate( 'gateway-portability-local-summary' )}</legend>";
        $buff .= '<table id="gateway-portability-local-summary" class="gateway-table zebra"><thead>';
        $buff .= "<tr><th>{$app->translate( 'gateway-portability-local-summary-source' )}</th><th>{$app->translate( 'gateway-portability-local-summary-count' )}</th><th>{$app->translate( 'gateway-portability-local-summary-update' )}</th></tr>";
        $buff .= '</thead><tbody></tbody></table></fieldset>';
        $buff .= "<br /><input type='button' value='{$app->translate( 'gateway-portability-local-import' )}' id='gateway-portability-local-import-button' />";

        $buff .= '<div id=\'gateway-portability-local-import-form-div\'>';
        $buff .= "<table id='gateway-portability-local-import' class='gateway-table-modal-form'><tbody><tr><td class='label'><label for='gateway-portability-local-import-file'>{$app->translate( 'gateway-portability-local-import-file' )}</label>: {$fmt->help( 'gateway-portability-local-import-file-help' )}</td><td><input type='file' id='gateway-portability-local-import-file' /><span id='gateway-portability-local-import-file-info'>&nbsp;</span></td></tr>";
        $buff .= "<tr><td class='label'><label for='gateway-portability-local-import-type'>{$app->translate( 'gateway-portability-local-import-type' )}</label>:</td><td><select id='gateway-portability-local-import-type'>";
        foreach( $portability->getAvailableImportTypes() as $type )
        {
            $key = "gateway-portability-local-import-type-{$type}";
            $buff .= "<option value='{$type}'>{$app->translate( $key )}</option>";
        }
        $buff .= '</select></td></tr>';
        $buff .= "<tr><td class='label'>{$app->translate( 'gateway-portability-local-import-format' )}: {$fmt->help( 'gateway-portability-local-import-format-help' )}</td><td><div id='gateway-portability-local-import-field-format'><select id='gateway-portability-local-import-field-format-tpl' class='displayNone'><option>&nbsp;</option>";
        foreach( $portability->getAvailableFormats() as $_fmt )
        {
            $key = "gateway-portability-local-import-format-{$_fmt}";
            $buff .= "<option value=\"{$_fmt}\">{$app->translate( $key )}</option>";
        }
        $buff .= '</select><ol id="gateway-portability-local-import-field-format-list"></ol></div></td></tr>';
        $buff .= "<tr><td class='label'><label for='gateway-portability-local-import-field-delimiter'>{$app->translate( 'gateway-portability-local-import-field-delimiter' )}</label>:</td><td><input type='text' value=',' id='gateway-portability-local-import-field-delimiter' class='field-config' maxlength='1' /></td></tr>";
        $buff .= "<tr><td class='label'><label for='gateway-portability-local-import-field-closure'>{$app->translate( 'gateway-portability-local-import-field-closure' )}</label>: {$fmt->help( 'gateway-portability-local-import-field-closure-help' )}</td><td><input type='text' value='\"' id='gateway-portability-local-import-field-closure' class='field-config' maxlength='1' /></td></tr>";
        $buff .= "<tr><td class='label'>{$app->translate( 'gateway-portability-local-import-options' )}:</td><td class='textAlignLeft'>";
        $buff .= "<input type='checkbox' id='gateway-portability-local-import-ignore-first-line' /> <label for='gateway-portability-local-import-ignore-first-line'>{$app->translate( 'gateway-portability-local-import-ignore-first-line' )} {$fmt->help( 'gateway-portability-local-import-ignore-first-line-help' )}</label><br />";
        $buff .= "<input type='checkbox' id='gateway-portability-local-import-incremental' /> <label for='gateway-portability-local-import-incremental'>{$app->translate( 'gateway-portability-local-import-incremental' )} {$fmt->help( 'gateway-portability-local-import-incremenetal-help' )}</label><br />";
        $buff .= "<input type='checkbox' id='gateway-portability-local-import-ignore-invalid' /> <label for='gateway-portability-local-import-ignore-invalid'>{$app->translate( 'gateway-portability-local-import-ignore-invalid' )} {$fmt->help( 'gateway-portability-local-import-ignore-invalid-help' )}</label>";
        $buff .= '</td></tr></tbody></table>';
        // upload bar
        $buff .= "<div id='gateway-portability-local-import-progress' class='displayNone'><br /><br />{$app->translate( 'gateway-portability-local-import-sending-file' )}<br /><br /><br />";
        $buff .= '<div id=\'gateway-portability-local-import-progress-bar\'><div class="progress-label">&nbsp;</div></div></div>';
        $buff .= '</div>';

        return $buff;
    }

    function importPortabilityFileGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayPortabilityImport.php';

        $app = KSystem::getInstance( );

        $return = array( 'success' => false, 'message' => 'gateway-portability-local-import-error' );
        try
        {
            $portability = KGatewayPortabilityImport::getInstance( );

            //TODO: file upload error checking
            //TODO: check input data
            $tmp = $portability->createTemporaryFileName( $_FILES['files']['name'][0] );
            move_uploaded_file( $_FILES['files']['tmp_name'][0], $tmp );

            $options = new KGatewayPortabilityOptions( );

            $options->fieldDelimiter = $_POST['FieldDelimiter'];
            $options->fieldClosure = $_POST['FieldClosure'];
            $options->ignoreErrors = $_POST['IgnoreErrors'] == 'true';
            $options->ignoreFirstLine = $_POST['IgnoreFirstLine'] == 'true';
            $options->incremental = $_POST['Incremental'] == 'true';

            $portability->run( $tmp, $_POST['Type'], $_POST['Format'], $options );

            $return = array( 'success' => true, 'message' => $app->translate( 'gateway-portability-local-import-started' ) );
        }
        catch( Exception $e )
        {
            $return['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $return );
    }
