<?php
    @session_start( );

    require_once 'chartPopulator.php';
    $AjaxFunctions['getChannelStatusChartData'] = 'getChannelStatusChartData';
    $AjaxFunctions['getCallStatusChartData'] = 'getCallStatusChartData';
    $AjaxFunctions['getFailStatusChartData'] = 'getFailStatusChartData';

    function getChannelStatusChartData( $_REQUEST )
    {
        $app = KSystem::getInstance( );
        if( isset( $_REQUEST['serial'] ) )
        {
            $serial = $_REQUEST['serial'];
            if( isset( $_REQUEST['link'] ) )
            {
                $link = $_REQUEST['link'];
                $f = ChartPopulator::getTotalFailByLink( $serial, $link );
                $b = ChartPopulator::getTotalBusyByLink( $serial, $link );
                $i = ChartPopulator::getTotalIdleByLink( $serial, $link );
            }
            else
            {
                $f = ChartPopulator::getTotalFailByDevice( $serial );
                $b = ChartPopulator::getTotalBusyByDevice( $serial );
                $i = ChartPopulator::getTotalIdleByDevice( $serial );
            }
            $arr = array( array( $app->translate( 'chart_leg_fail' ), intval( $f ) ), array( $app->translate( 'chart_leg_busy' ), intval( $b ) ), array( $app->translate( 'chart_leg_idle' ), intval( $i ) ) );
            $data = array( 'success' => true, 'message' => '', 'content' => $arr );
        }
        else
            $data = array( 'success' => false, 'message' => $app->translate( 'chart_leg_nodata' ), 'content' => array( ) );

        return JSONencode( $data );
    }

    function getCallStatusChartData( $_REQUEST )
    {
        $app = KSystem::getInstance( );
        if( isset( $_REQUEST['serial'] ) )
        {
            $serial = $_REQUEST['serial'];
            if( isset( $_REQUEST['link'] ) )
            {
                $link = $_REQUEST['link'];
                $info = ChartPopulator::getCallStatsByLink( $serial, $link );
            }
            else if( isset( $_REQUEST['channel'] ) )
            {
                $channel = $_REQUEST['channel'];
                $info = ChartPopulator::getCallStatsByChannel( $serial, $channel );
            }
            else
            {
                $info = ChartPopulator::getCallStatsByDevice( $serial );
            }

            if( intval( implode( '', $info ) ) )
            {
                $incoming = intval( $info[0] );
                $qtde = intval( $info[1] );
                $completed = intval( $info[2] );
                $fail = intval( $info[3] );

                $not_asw = $qtde != ($completed + $fail) ? $qtde - ($completed + $fail) : 0;
                $incOut = array( array( $app->translate( 'chart_leg_incoming' ), $incoming ), array( $app->translate( 'chart_leg_outgoing' ), $qtde ) );

                if( $qtde > 0 )
                {
                    $incDet = array( array( $app->translate( 'chart_leg_failed' ), $fail ), array( $app->translate( 'chart_leg_completed' ), $completed ), array( $app->translate( 'chart_leg_others' ), $not_asw ) );
                    $arr = array( $incOut, $incDet );
                }
                else
                    $arr = array( $incOut );

                $data = array( 'success' => true, 'message' => '', 'content' => $arr );
            }
            else
                $data = array( 'success' => false, 'message' => $app->translate( 'chart_leg_nodata' ), 'content' => array( ) );
        }
        else
            $data = array( 'success' => false, 'message' => $app->translate( 'chart_leg_nodata' ), 'content' => array( ) );

        return JSONencode( $data );
    }

    function getFailStatusChartData( $_REQUEST )
    {
        $app = KSystem::getInstance( );
        if( isset( $_REQUEST['serial'] ) )
        {
            $serial = $_REQUEST['serial'];
            if( isset( $_REQUEST['link'] ) )
            {
                $link = $_REQUEST['link'];
                $info = ChartPopulator::getFailStatsByLink( $serial, $link );
            }
            else if( isset( $_REQUEST['channel'] ) )
            {
                $channel = $_REQUEST['channel'];
                $info = ChartPopulator::getFailStatsByChannel( $serial, $channel );
            }
            else
            {
                $info = ChartPopulator::getFailStatsByDevice( $serial );
            }
            if( intval( implode( '', $info ) ) )
            {
                $arr = array( array( $app->translate( 'chart_leg_ch_busy' ), intval( $info[0] ) ), array( $app->translate( 'chart_leg_not_answered' ), intval( $info[1] ) ), array( $app->translate( 'chart_leg_rejected' ), intval( $info[2] ) ), array( $app->translate( 'chart_leg_changed_numb' ), intval( $info[3] ) ), array( $app->translate( 'chart_leg_invalid_numb' ), intval( $info[4] ) ), array( $app->translate( 'chart_leg_no_service' ), intval( $info[5] ) ), array( $app->translate( 'chart_leg_congestion' ), intval( $info[6] ) ), array( $app->translate( 'chart_leg_network_fail' ), intval( $info[7] ) ), array( $app->translate( 'chart_leg_other_fail' ), intval( $info[8] ) ) );
                $data = array( 'success' => true, 'message' => '', 'content' => $arr );
            }
            else
                $data = array( 'success' => false, 'message' => $app->translate( 'chart_leg_nodata' ), 'content' => array( ) );
        }
        else
            $data = array( 'success' => false, 'message' => $app->translate( 'chart_leg_nodata' ), 'content' => array( ) );

        return JSONencode( $data );
    }
