<?php
    require_once ('constants_snmp.php');
    class ChartPopulator extends Constants_SNMP
    {
        public static function getTotalIdleByDevice( $serial )
        {
            $tag = self::K3LDEVICECHANNELCOUNTIDLE;
            Querist::ask( "OID $tag.$serial", $idle_total );
            return $idle_total;
        }

        public static function getTotalIdleByLink( $serial, $link = '0' )
        {
            $tag = self::K3LDEVICELINKCHANNELCOUNTIDLE;
            Querist::ask( "OID $tag.$serial.$link", $idle_total );
            return $idle_total;
        }

        public static function getTotalBusyByDevice( $serial )
        {
            $tag = self::K3LDEVICECHANNELCOUNTBUSY;
            Querist::ask( "OID $tag.$serial", $busy_total );
            return $busy_total;
        }

        public static function getTotalBusyByLink( $serial, $link = '0' )
        {
            $tag = self::K3LDEVICELINKCHANNELCOUNTBUSY;
            Querist::ask( "OID $tag.$serial.$link", $busy_total );
            return $busy_total;
        }

        public static function getTotalFailByDevice( $serial )
        {
            $tag = self::K3LDEVICECHANNELCOUNTFAIL;
            Querist::ask( "OID $tag.$serial", $fail_total );
            return $fail_total;
        }

        public static function getTotalFailByLink( $serial, $link )
        {
            $tag = self::K3LDEVICELINKCHANNELCOUNTFAIL;
            Querist::ask( "OID $tag.$serial.$link", $fail_total );
            return $fail_total;
        }

        public static function getCallStatsByDevice( $serial )
        {
            $arr_oids = array( self::K3LDEVICESTATSINCOMING, self::K3LDEVICESTATSOUTGOING, self::K3LDEVICEOUTGOINGCOMPLETED, self::K3LDEVICEOUTGOINGERROR);
            for( $i = 0; $i < sizeof( $arr_oids ); $i++ )
                $arr_oids[$i] = "OID {$arr_oids[$i]}.{$serial}";
            Querist::ask( implode( ';', $arr_oids ), $stats );
            return explode( ';', $stats );
        }

        public static function getCallStatsByLink( $serial, $link )
        {
            $arr_oids = array( self::K3LDEVICELINKSTATSINCOMING, self::K3LDEVICELINKSTATSOUTGOING, self::K3LDEVICELINKOUTGOINGCOMPLETED, self::K3LDEVICELINKOUTGOINGERROR );
            for( $i = 0; $i < sizeof( $arr_oids ); $i++ )
                $arr_oids[$i] = "OID {$arr_oids[$i]}.{$serial}.{$link}";
            Querist::ask( implode( ';', $arr_oids ), $stats );
            return explode( ';', $stats );
        }

        public static function getCallStatsByChannel( $serial, $channel )
        {
            $arr_oids = array( self::K3LDEVICECHANNELSTATSINCOMING, self::K3LDEVICECHANNELSTATSOUTGOING, self::K3LDEVICECHANNELSTATSOUTGOINGCOMPLETED, self::K3LDEVICECHANNELSTATSOUTGOINGERROR);
            for( $i = 0; $i < sizeof( $arr_oids ); $i++ )
                $arr_oids[$i] = "OID {$arr_oids[$i]}.{$serial}.{$channel}";
            Querist::ask( implode( ';', $arr_oids ), $stats );
            return explode( ';', $stats );
        }

        public static function getFailStatsByDevice( $serial )
        {
            $arr_oids = array( self::K3LDEVICECALLFAILBUSY, self::K3LDEVICECALLFAILNOANSWER, self::K3LDEVICECALLFAILREJECTED, self::K3LDEVICECALLFAILCHANGEDNUMBER, self::K3LDEVICECALLFAILINVALIDNUMBER, self::K3LDEVICECALLFAILOUTOFSERVICE, self::K3LDEVICECALLFAILCONGESTION, self::K3LDEVICECALLFAILNETWORKFAILURE, self::K3LDEVICECALLFAILOTHER );
            for( $i = 0; $i < sizeof( $arr_oids ); $i++ )
                $arr_oids[$i] = "OID {$arr_oids[$i]}.{$serial}";
            Querist::ask( implode( ';', $arr_oids ), $stats );
            return explode( ';', $stats );
        }

        public static function getFailStatsByLink( $serial, $link )
        {
            $arr_oids = array( self::K3LDEVICELINKCALLFAILBUSY, self::K3LDEVICELINKCALLFAILNOANSWER, self::K3LDEVICELINKCALLFAILREJECTED, self::K3LDEVICELINKCALLFAILCHANGEDNUMBER, self::K3LDEVICELINKCALLFAILINVALIDNUMBER, self::K3LDEVICELINKCALLFAILOUTOFSERVICE, self::K3LDEVICELINKCALLFAILCONGESTION, self::K3LDEVICELINKCALLFAILNETWORKFAILURE, self::K3LDEVICELINKCALLFAILOTHER );
            for( $i = 0; $i < sizeof( $arr_oids ); $i++ )
                $arr_oids[$i] = "OID {$arr_oids[$i]}.{$serial}.{$link}";
            Querist::ask( implode( ';', $arr_oids ), $stats );
            return explode( ';', $stats );
        }

        public static function getFailStatsByChannel( $serial, $channel )
        {
            $arr_oids = array( self::K3LDEVICECHANNELSTATSCALLFAILBUSY, self::K3LDEVICECHANNELSTATSCALLFAILNOANSWER, self::K3LDEVICECHANNELSTATSCALLFAILREJECTED, self::K3LDEVICECHANNELSTATSCALLFAILCHANGEDNUMBER, self::K3LDEVICECHANNELSTATSCALLFAILINVALIDNUMBER, self::K3LDEVICECHANNELSTATSCALLFAILOUTOFSERVICE, self::K3LDEVICECHANNELSTATSCALLFAILCONGESTION, self::K3LDEVICECHANNELSTATSCALLFAILNETWORKFAILURE, self::K3LDEVICECHANNELSTATSCALLFAILOTHER );
            for( $i = 0; $i < sizeof( $arr_oids ); $i++ )
                $arr_oids[$i] = "OID {$arr_oids[$i]}.{$serial}.{$channel}}";
            Querist::ask( implode( ';', $arr_oids ), $stats );
            return explode( ';', $stats );
        }

    }
